/*
Dataddo Headless BETA API

Dataddo Headless BETA API

API version: 1.0.0-beta.1
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package customer_api

import (
	"encoding/json"
)

// checks if the ExactOnlineStorageRequest type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &ExactOnlineStorageRequest{}

// ExactOnlineStorageRequest struct for ExactOnlineStorageRequest
type ExactOnlineStorageRequest struct {
	Label    *string `json:"label,omitempty"`
	Type     *string `json:"type,omitempty"`
	OAuthId  *int32  `json:"o_auth_id,omitempty"`
	Endpoint *string `json:"endpoint,omitempty"`
}

// NewExactOnlineStorageRequest instantiates a new ExactOnlineStorageRequest object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewExactOnlineStorageRequest() *ExactOnlineStorageRequest {
	this := ExactOnlineStorageRequest{}
	return &this
}

// NewExactOnlineStorageRequestWithDefaults instantiates a new ExactOnlineStorageRequest object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewExactOnlineStorageRequestWithDefaults() *ExactOnlineStorageRequest {
	this := ExactOnlineStorageRequest{}
	return &this
}

// GetLabel returns the Label field value if set, zero value otherwise.
func (o *ExactOnlineStorageRequest) GetLabel() string {
	if o == nil || IsNil(o.Label) {
		var ret string
		return ret
	}
	return *o.Label
}

// GetLabelOk returns a tuple with the Label field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ExactOnlineStorageRequest) GetLabelOk() (*string, bool) {
	if o == nil || IsNil(o.Label) {
		return nil, false
	}
	return o.Label, true
}

// HasLabel returns a boolean if a field has been set.
func (o *ExactOnlineStorageRequest) HasLabel() bool {
	if o != nil && !IsNil(o.Label) {
		return true
	}

	return false
}

// SetLabel gets a reference to the given string and assigns it to the Label field.
func (o *ExactOnlineStorageRequest) SetLabel(v string) {
	o.Label = &v
}

// GetType returns the Type field value if set, zero value otherwise.
func (o *ExactOnlineStorageRequest) GetType() string {
	if o == nil || IsNil(o.Type) {
		var ret string
		return ret
	}
	return *o.Type
}

// GetTypeOk returns a tuple with the Type field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ExactOnlineStorageRequest) GetTypeOk() (*string, bool) {
	if o == nil || IsNil(o.Type) {
		return nil, false
	}
	return o.Type, true
}

// HasType returns a boolean if a field has been set.
func (o *ExactOnlineStorageRequest) HasType() bool {
	if o != nil && !IsNil(o.Type) {
		return true
	}

	return false
}

// SetType gets a reference to the given string and assigns it to the Type field.
func (o *ExactOnlineStorageRequest) SetType(v string) {
	o.Type = &v
}

// GetOAuthId returns the OAuthId field value if set, zero value otherwise.
func (o *ExactOnlineStorageRequest) GetOAuthId() int32 {
	if o == nil || IsNil(o.OAuthId) {
		var ret int32
		return ret
	}
	return *o.OAuthId
}

// GetOAuthIdOk returns a tuple with the OAuthId field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ExactOnlineStorageRequest) GetOAuthIdOk() (*int32, bool) {
	if o == nil || IsNil(o.OAuthId) {
		return nil, false
	}
	return o.OAuthId, true
}

// HasOAuthId returns a boolean if a field has been set.
func (o *ExactOnlineStorageRequest) HasOAuthId() bool {
	if o != nil && !IsNil(o.OAuthId) {
		return true
	}

	return false
}

// SetOAuthId gets a reference to the given int32 and assigns it to the OAuthId field.
func (o *ExactOnlineStorageRequest) SetOAuthId(v int32) {
	o.OAuthId = &v
}

// GetEndpoint returns the Endpoint field value if set, zero value otherwise.
func (o *ExactOnlineStorageRequest) GetEndpoint() string {
	if o == nil || IsNil(o.Endpoint) {
		var ret string
		return ret
	}
	return *o.Endpoint
}

// GetEndpointOk returns a tuple with the Endpoint field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ExactOnlineStorageRequest) GetEndpointOk() (*string, bool) {
	if o == nil || IsNil(o.Endpoint) {
		return nil, false
	}
	return o.Endpoint, true
}

// HasEndpoint returns a boolean if a field has been set.
func (o *ExactOnlineStorageRequest) HasEndpoint() bool {
	if o != nil && !IsNil(o.Endpoint) {
		return true
	}

	return false
}

// SetEndpoint gets a reference to the given string and assigns it to the Endpoint field.
func (o *ExactOnlineStorageRequest) SetEndpoint(v string) {
	o.Endpoint = &v
}

func (o ExactOnlineStorageRequest) MarshalJSON() ([]byte, error) {
	toSerialize, err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o ExactOnlineStorageRequest) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	if !IsNil(o.Label) {
		toSerialize["label"] = o.Label
	}
	if !IsNil(o.Type) {
		toSerialize["type"] = o.Type
	}
	if !IsNil(o.OAuthId) {
		toSerialize["o_auth_id"] = o.OAuthId
	}
	if !IsNil(o.Endpoint) {
		toSerialize["endpoint"] = o.Endpoint
	}
	return toSerialize, nil
}

type NullableExactOnlineStorageRequest struct {
	value *ExactOnlineStorageRequest
	isSet bool
}

func (v NullableExactOnlineStorageRequest) Get() *ExactOnlineStorageRequest {
	return v.value
}

func (v *NullableExactOnlineStorageRequest) Set(val *ExactOnlineStorageRequest) {
	v.value = val
	v.isSet = true
}

func (v NullableExactOnlineStorageRequest) IsSet() bool {
	return v.isSet
}

func (v *NullableExactOnlineStorageRequest) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableExactOnlineStorageRequest(val *ExactOnlineStorageRequest) *NullableExactOnlineStorageRequest {
	return &NullableExactOnlineStorageRequest{value: val, isSet: true}
}

func (v NullableExactOnlineStorageRequest) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableExactOnlineStorageRequest) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}
